//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation
import JSONUtilities

extension API.ApiFoyer {

    /** Permet de récuperer le foyer correpondant à l'identifiant */
    public enum GetApiFoyerGetFoyer {

        public static let service = APIService<Response>(id: "getApiFoyerGetFoyer", tag: "Api Foyer", method: "GET", path: "/apiFoyer/getFoyer", hasBody: false)

        public final class Request: APIRequest<Response> {

            public struct Options {

                public var idFoyer: String

                public init(idFoyer: String) {
                    self.idFoyer = idFoyer
                }
            }

            public var options: Options

            public init(options: Options) {
                self.options = options
                super.init(service: GetApiFoyerGetFoyer.service)
            }

            /// convenience initialiser so an Option doesn't have to be created
            public convenience init(idFoyer: String) {
                let options = Options(idFoyer: idFoyer)
                self.init(options: options)
            }

            public override var parameters: [String: Any] {
                var params: JSONDictionary = [:]
                params["idFoyer"] = options.idFoyer
                return params
            }
        }

        public enum Response: APIResponseValue, CustomStringConvertible, CustomDebugStringConvertible {
            public typealias SuccessType = Foyer

            /** Succes */
            case status200(Foyer)

            public var success: Foyer? {
                switch self {
                case .status200(let response): return response
                }
            }

            public var response: Any {
                switch self {
                case .status200(let response): return response
                }
            }

            public var statusCode: Int {
                switch self {
                case .status200: return 200
                }
            }

            public var successful: Bool {
                switch self {
                case .status200: return true
                }
            }

            public init(statusCode: Int, data: Data) throws {
                switch statusCode {
                case 200: self = try .status200(JSONDecoder.decode(data: data))
                default: throw APIError.unexpectedStatusCode(statusCode: statusCode, data: data)
                }
            }

            public var description: String {
                return "\(statusCode) \(successful ? "success" : "failure")"
            }

            public var debugDescription: String {
                var string = description
                let responseString = "\(response)"
                if responseString != "()" {
                    string += "\n\(responseString)"
                }
                return string
            }
        }
    }
}
